#!/bin/sh

cache=.update_ip.cache
server=ns1.example.com
zone=dyn.example.com
host=desktop
secret=""

ip=$(wget -q -O - http://alma.ch/myip.cgi)

if [ -z ${ip} ] || [ -z ${cache} ]; then
	exit;
fi      

if [ -f "${HOME}/${cache}" ]; then
	old_ip=$(cat "${HOME}/${cache}")
fi

if [ "${ip}" = "${old_ip}" ]; then
	exit;
else
	rm -f "${HOME}/${cache}"
	echo "${ip}" > "${HOME}/${cache}"
fi

cat <<EOF | nsupdate
server ${server}
zone ${zone}.
key ${host}.${zone} ${secret}
update delete ${host}.${zone}.
update add ${host}.${zone}. 60 A $ip
update add ${host}.${zone}. 60 TXT "Updated on $(date)"
send
EOF
